pcl::PCLSurfaceBase< PointInT > Class Template Referenceabstract

Pure abstract class. More...

`#include <pcl/surface/reconstruction.h>`

Inheritance diagram for pcl::PCLSurfaceBase< PointInT >:

## Public Types

using | Ptr = shared_ptr< PCLSurfaceBase< PointInT > >
using | ConstPtr = shared_ptr< const PCLSurfaceBase< PointInT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| PCLSurfaceBase ()
| Empty constructor. More...
| ~PCLSurfaceBase ()
| Empty destructor. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide an optional pointer to a search object. More...
KdTreePtr | getSearchMethod ()
| Get a pointer to the search method used. More...
virtual void | reconstruct (pcl::PolygonMesh &output)=0
| Base method for surface reconstruction for all points given in <setInputCloud (), setIndices ()> More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual std::string | getClassName () const
| Abstract class get name method. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

KdTreePtr | tree_
| A pointer to the spatial search object. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT>
class pcl::PCLSurfaceBase< PointInT >

Pure abstract class.

All types of meshing/reconstruction algorithms in libpcl_surface must inherit from this, in order to make sure we have a consistent API. The methods that we care about here are:

- setSearchMethod(&SearchPtr): passes a search locator
- reconstruct(&PolygonMesh): creates a PolygonMesh object from the input data

Author
  Radu B. Rusu, Michael Dixon, Alexandru E. Ichim

Definition at line 60 of file reconstruction.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT>

using pcl::PCLSurfaceBase< PointInT >::ConstPtr = shared_ptr<const PCLSurfaceBase<PointInT> >

Definition at line 64 of file reconstruction.h.

## KdTree

template<typename PointInT>

using pcl::PCLSurfaceBase< PointInT >::KdTree = pcl::search::Search<PointInT>

Definition at line 66 of file reconstruction.h.

## KdTreePtr

template<typename PointInT>

using pcl::PCLSurfaceBase< PointInT >::KdTreePtr = typename KdTree::Ptr

Definition at line 67 of file reconstruction.h.

## Ptr

template<typename PointInT>

using pcl::PCLSurfaceBase< PointInT >::Ptr = shared_ptr<PCLSurfaceBase<PointInT> >

Definition at line 63 of file reconstruction.h.

## Constructor & Destructor Documentation

## PCLSurfaceBase()

template<typename PointInT>

pcl::PCLSurfaceBase< PointInT >::PCLSurfaceBase | ( |  | ) |

inline

Empty constructor.

Definition at line 70 of file reconstruction.h.

## ~PCLSurfaceBase()

template<typename PointInT>

pcl::PCLSurfaceBase< PointInT >::~PCLSurfaceBase | ( |  | ) |

inline

Empty destructor.

Definition at line 73 of file reconstruction.h.

## Member Function Documentation

## getClassName()

template<typename PointInT>

virtual std::string pcl::PCLSurfaceBase< PointInT >::getClassName | ( |  | ) | const

inline protected virtual

Abstract class get name method.

Reimplemented in pcl::MarchingCubes< PointNT >, pcl::ConvexHull< PointInT >, pcl::Poisson< PointNT >, and pcl::ConcaveHull< PointInT >.

Definition at line 101 of file reconstruction.h.

## getSearchMethod()

template<typename PointInT>

KdTreePtr pcl::PCLSurfaceBase< PointInT >::getSearchMethod | ( |  | ) |

inline

Get a pointer to the search method used.

Definition at line 86 of file reconstruction.h.

## reconstruct()

template<typename PointInT>

virtual void pcl::PCLSurfaceBase< PointInT >::reconstruct | ( | pcl::PolygonMesh & | output | ) |

pure virtual

Base method for surface reconstruction for all points given in <setInputCloud (), setIndices ()>

Parameters

  [out] | output | the resultant reconstructed surface model

Implemented in pcl::MeshConstruction< PointInT >, pcl::SurfaceReconstruction< PointInT >, and pcl::SurfaceReconstruction< PointNT >.

## setSearchMethod()

template<typename PointInT>

void pcl::PCLSurfaceBase< PointInT >::setSearchMethod | ( | const KdTreePtr & | tree | ) |

inline

Provide an optional pointer to a search object.

Parameters

  [in] | tree | a pointer to the spatial search object.

Definition at line 79 of file reconstruction.h.

## Member Data Documentation

## tree_

template<typename PointInT>

KdTreePtr pcl::PCLSurfaceBase< PointInT >::tree_

protected

A pointer to the spatial search object.

Definition at line 97 of file reconstruction.h.

Referenced by pcl::PCLSurfaceBase< PointNT >::getSearchMethod(), and pcl::PCLSurfaceBase< PointNT >::setSearchMethod().

The documentation for this class was generated from the following file:

- pcl/surface/reconstruction.h